Object.defineProperty(exports, "__esModule", { value: true });
exports.FilesHandler = void 0;
var fs_1 = require("fs");
var path_1 = require("path");
var MimeTypes_1 = require("../Tools/MimeTypes");
var FilesHandler = /** @class */ (function () {
    function FilesHandler(errorsHandler) {
        this.errorsHandler = errorsHandler;
    }
    /**
     * @summary Send a file:
     */
    FilesHandler.prototype.HandleFile = function (fileFullPath, fileName, stats, res) {
        var extension = path_1.extname('x.' + fileName);
        if (extension)
            extension = extension.substr(1);
        var mimeType = MimeTypes_1.Headers.GetMimeTypeByExtension(extension);
        var readStream = fs_1.createReadStream(path_1.normalize(fileFullPath));
        if (mimeType)
            res.SetHeader('Content-Type', mimeType);
        res.SetHeader('Content-Length', stats.size)
            .SetHeader('Last-Modified', stats.mtime.toUTCString())
            .SendHeaders(200);
        readStream.pipe(res, { end: true });
        readStream.on('end', function () {
            res['endHttpRequest']();
        });
    };
    return FilesHandler;
}());
exports.FilesHandler = FilesHandler;
//# sourceMappingURL=File.js.map