import { Request } from "../Request";
export declare class Other {
    /**
     * Http method (upper case) - `GET`, `POST`, `PUT`, `HEAD`...
     * Example: `"GET"`
     * @var string|NULL
     */
    protected httpMethod?: string;
    /**
     * `true` if request is requested from browser by `XmlHttpRequest` object
     * with http header: `X-Requested-With: AnyJavascriptFrameworkName`, `false` otherwise.
     */
    protected ajax?: boolean;
    /**
     * Referer URI if any, safely read from header `Referer`.
     * Example: `"http://foreing.domain.com/path/where/is/link/to/?my=app"`
     * @var string|NULL
     */
    protected referer?: string;
    /**
     * Server IP address string.
     * Example: `"127.0.0.1" | "111.222.111.222"`
     * @var string|NULL
     */
    protected serverIp?: string;
    /**
     * Client IP address string.
     * Example: `"127.0.0.1" | "222.111.222.111"`
     */
    protected clientIp?: string;
    /**
     * Integer value from header `Content-Length`,
     * `NULL` if no value presented in headers object.
     * Example: `123456 | NULL`
     */
    protected contentLength?: number;
    /**
     * Timestamp of the start of the request in miliseconds.
     */
    protected startTime?: number;
    SetMethod(rawMethod: string): Request;
    GetMethod(): string;
    IsAjax(): boolean;
    GetReferer(rawInput?: boolean): string;
    SetServerIp(serverIp: string): Request;
    GetServerIp(): string;
    SetClientIp(clientIp: string): Request;
    GetClientIp(): string;
    GetContentLength(): number | null;
    GetStartTime(): number;
}
